CREATE OR ALTER VIEW "IDM_RPT_DATA"."IDMRPT_RES_TRUST_V" ("RES_ID", "RES_NAME", "RES_DN", "RES_DESC", "IDMRPT_SYN_STATE", "ROLE_NAME", "IDV_NAME1", "LAST_NAME", "FIRST_NAME", "MIDDLE_INITIAL", "TRUST_START_TIME", "TRUST_EXPIRATION_TIME", "IDMRPT_VALID_TO", "IDMRPT_VALID_FROM", "IDENTITY_ID", "REQUESTER_ID", "TRUST_TYPE_ID", "IDM_RPT_DELETED", "ENT_DN", "ENT_NAME", "DRIVER_DN", "DRIVER_NAME", "FAKE_FUTURE_DATE", "ENT_VALUE", "IDV_ENT_ID", "LIID", "IDMRPT_RESOURCE_VALID_TO", "IDMRPT_IDENTITY_VALID_TO", "IDMRPT_IDENTITY_IDENTITY_ID", "ENT_IDMRPT_VALID_TO", "ENT_IDV_ENT_ID") AS 
 SELECT TOP 100 PERCENT
    idmrpt_resource.res_id,
    COALESCE(idmrpt_resource.res_name, idmrpt_resource.res_dn) AS res_name,
    idmrpt_resource.res_dn,
    idmrpt_resource.res_desc,
    idmrpt_resource.idmrpt_syn_state,
        CASE
            WHEN lower(convert(varchar, idmrpt_idv_identity_trust.cause_type)) = lower(convert(varchar, 'role driver')) THEN (convert(varchar, rela.role_name) + convert(varchar, ' -- ')) + convert(varchar, rela.role_descr)
            ELSE NULL
        END AS role_name,
        CASE
            WHEN rtrim(ltrim(convert(varchar, idmrpt_rpt_driver.idv_host))) = rtrim(ltrim(convert(varchar, idmrpt_rpt_driver.idv_name))) THEN convert(varchar, idmrpt_rpt_driver.idv_name)
            ELSE ((convert(varchar, idmrpt_rpt_driver.idv_name) + convert(varchar, ' (')) + convert(varchar, idmrpt_rpt_driver.idv_host)) + convert(varchar, ')')
        END AS idv_name1,
    idmrpt_identity.last_name,
    idmrpt_identity.first_name,
    idmrpt_identity.middle_initial,
    idmrpt_idv_identity_trust.trust_start_time,
    idmrpt_idv_identity_trust.trust_expiration_time,
    idmrpt_idv_identity_trust.idmrpt_valid_to,
    idmrpt_idv_identity_trust.idmrpt_valid_from,
    idmrpt_idv_identity_trust.identity_id,
    idmrpt_idv_identity_trust.requester_id,
    idmrpt_idv_identity_trust.trust_type_id,
    idmrpt_idv_identity_trust.idmrpt_deleted AS idm_rpt_deleted,
    ent.idmrpt_ent_dn ent_dn,
    ent.idmrpt_ent_name ent_name,
    driver.drv_dn driver_dn,
    driver.drv_name driver_name,
    convert(varchar, CURRENT_TIMESTAMP + 7305 , 120) fake_future_date,
        CASE
            WHEN convert(varchar, bind_v.ent_param_str) LIKE convert(varchar, '%ID2%') THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_data.idmrpt_ms_ent_cs_v
              WHERE convert(varchar, idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTRING(convert(varchar, bind_v.ent_param_str), CHARINDEX(convert(varchar, 'ID2'), convert(varchar, bind_v.ent_param_str)) + 6, CHARINDEX(convert(varchar, '}'), SUBSTRING(convert(varchar, bind_v.ent_param_str), CHARINDEX(convert(varchar, 'ID2'), convert(varchar, bind_v.ent_param_str)) + 6, LEN(convert(varchar, bind_v.ent_param_str)))) - 2))
            WHEN convert(varchar, bind_v.ent_param_str) LIKE convert(varchar, '%ID%') THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_data.idmrpt_ms_ent_cs_v
              WHERE convert(varchar, idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTRING(convert(varchar, bind_v.ent_param_str), CHARINDEX(convert(varchar, 'ID'), convert(varchar, bind_v.ent_param_str)) + 5, CHARINDEX(convert(varchar, '}'), SUBSTRING(convert(varchar, bind_v.ent_param_str), CHARINDEX(convert(varchar, 'ID'), convert(varchar, bind_v.ent_param_str)) + 5, LEN(convert(varchar, bind_v.ent_param_str)))) - 2))
            WHEN convert(varchar, bind_v.ent_param_str) = convert(varchar, '%EntitlementParamKey%') OR convert(varchar, bind_v.ent_param_val) = convert(varchar, '%EntitlementParamKey%') THEN
            CASE
                WHEN convert(varchar, idmrpt_idv_identity_trust.trust_params) LIKE convert(varchar, '%ID2%') THEN convert(varchar, (( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_data.idmrpt_ms_ent_cs_v
                  WHERE convert(varchar, idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'ID2'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 6, CHARINDEX(convert(varchar, '}'), SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'ID2'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 6, LEN(convert(varchar, idmrpt_idv_identity_trust.trust_params)))) - 2))))
                WHEN convert(varchar, idmrpt_idv_identity_trust.trust_params) LIKE convert(varchar, '%ID%') THEN convert(varchar, (( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_data.idmrpt_ms_ent_cs_v
                  WHERE convert(varchar, idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'ID'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 5, CHARINDEX(convert(varchar, '}'), SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'ID'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 5, LEN(convert(varchar, idmrpt_idv_identity_trust.trust_params)))) - 2))))
                ELSE SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'EntitlementParamKey'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 21, CHARINDEX(convert(varchar, '</value>'), SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'EntitlementParamKey'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 21, LEN(convert(varchar, idmrpt_idv_identity_trust.trust_params)))) - 1)
            END
            ELSE bind_v.ent_param_val
        END ent_value,
    ent.idv_ent_id,
    bind_v.ent_param_liid liid,
    idmrpt_resource.idmrpt_valid_to idmrpt_resource_valid_to,
    idmrpt_identity.idmrpt_valid_to idmrpt_identity_valid_to,
    idmrpt_identity.identity_id  idmrpt_identity_identity_id,
    ent.idmrpt_valid_to ent_idmrpt_valid_to,
    ent.idv_ent_id ent_idv_ent_id
   FROM idm_rpt_data.idmrpt_rpt_driver_v idmrpt_rpt_driver,
    idm_rpt_data.idmrpt_idv_v idmrpt_idv,
    idm_rpt_data.idmrpt_identity_v idmrpt_identity,
    idm_rpt_data.idmrpt_idv_identity_trust_v idmrpt_idv_identity_trust,
    idm_rpt_data.idmrpt_resource_v idmrpt_resource
     LEFT JOIN idm_rpt_data.idmrpt_idv_ent_bindings_v bind_v ON convert(varchar, bind_v.ent_id) = convert(varchar, idmrpt_resource.res_id)
     LEFT JOIN idm_rpt_data.idmrpt_idv_ent_v ent ON convert(varchar, bind_v.ent_id) = convert(varchar, ent.idv_ent_id)
     LEFT JOIN idm_rpt_data.idmrpt_idv_drivers_v driver ON convert(varchar, ent.idv_driver_id) = convert(varchar, driver.idv_driver_id)
     LEFT JOIN idm_rpt_data.idmrpt_r_to_res_relationship_v rela ON convert(varchar, idmrpt_resource.res_id) = convert(varchar, rela.res_id)
  WHERE convert(varchar, idmrpt_resource.res_id) = convert(varchar, idmrpt_idv_identity_trust.trust_obj_id) AND convert(varchar, idmrpt_rpt_driver.idv_id) = convert(varchar, idmrpt_idv.idv_id) AND
        CASE
            WHEN idmrpt_resource.rpt_drv_id IS NULL 
            THEN 1
            WHEN convert(varchar, idmrpt_rpt_driver.rpt_drv_id) = convert(varchar, idmrpt_resource.rpt_drv_id)
            THEN 1 
            ELSE 0
        END = 1  AND convert(varchar, idmrpt_idv.idv_id) = convert(varchar, idmrpt_resource.idv_id) AND convert(varchar, idmrpt_idv_identity_trust.identity_id) = convert(varchar, idmrpt_identity.identity_id) AND idmrpt_idv_identity_trust.trust_status = 1 AND
        CASE
            WHEN lower(convert(varchar, idmrpt_idv_identity_trust.cause_type)) = lower(convert(varchar, 'role driver')) 
            THEN (( SELECT count(1) AS count
               FROM idm_rpt_data.idmrpt_idv_identity_trust_v identity_trust
              WHERE convert(varchar, identity_trust.trust_obj_id) = convert(varchar, rela.role_id) AND convert(varchar, identity_trust.identity_id) = convert(varchar, idmrpt_idv_identity_trust.identity_id)))
            ELSE 1
        END = 1
  ORDER BY (COALESCE(idmrpt_resource.res_name, idmrpt_resource.res_dn)), (
        CASE
            WHEN lower(convert(varchar, idmrpt_idv_identity_trust.cause_type)) = lower(convert(varchar, 'role driver')) THEN (convert(varchar, rela.role_name) + convert(varchar, ' -- ')) + convert(varchar, rela.role_descr)
            ELSE NULL
        END), idmrpt_idv_identity_trust.trust_start_time, idmrpt_idv_identity_trust.idmrpt_valid_to, driver.drv_name, 
        (
        CASE
            WHEN convert(varchar, bind_v.ent_param_str) LIKE convert(varchar, '%ID2%') THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_data.idmrpt_ms_ent_cs_v
              WHERE convert(varchar, idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTRING(convert(varchar, bind_v.ent_param_str), CHARINDEX(convert(varchar, 'ID2'), convert(varchar, bind_v.ent_param_str)) + 6, CHARINDEX(convert(varchar, '}'), SUBSTRING(convert(varchar, bind_v.ent_param_str), CHARINDEX(convert(varchar, 'ID2'), convert(varchar, bind_v.ent_param_str)) + 6, LEN(convert(varchar, bind_v.ent_param_str)))) - 2))
            WHEN convert(varchar, bind_v.ent_param_str) LIKE convert(varchar, '%ID%') THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_data.idmrpt_ms_ent_cs_v
              WHERE convert(varchar, idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTRING(convert(varchar, bind_v.ent_param_str), CHARINDEX(convert(varchar, 'ID2'), convert(varchar, bind_v.ent_param_str)) + 6, CHARINDEX(convert(varchar, '}'), SUBSTRING(convert(varchar, bind_v.ent_param_str), CHARINDEX(convert(varchar, 'ID'), convert(varchar, bind_v.ent_param_str)) + 6, LEN(convert(varchar, bind_v.ent_param_str)))) - 2))
            WHEN convert(varchar, bind_v.ent_param_str) = convert(varchar, '%EntitlementParamKey%') OR  convert(varchar, bind_v.ent_param_val) = convert(varchar, '%EntitlementParamKey%') THEN
            CASE
                WHEN convert(varchar, idmrpt_idv_identity_trust.trust_params) LIKE  convert(varchar, '%ID2%') THEN convert(varchar, (( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_data.idmrpt_ms_ent_cs_v
                  WHERE convert(varchar, idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'ID2'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 6, CHARINDEX(convert(varchar, '}'), SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'ID2'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 6, LEN(convert(varchar, idmrpt_idv_identity_trust.trust_params)))) - 2))))
                WHEN convert(varchar, idmrpt_idv_identity_trust.trust_params) LIKE convert(varchar, '%ID%') THEN convert(varchar, (( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_data.idmrpt_ms_ent_cs_v
                  WHERE convert(varchar, idmrpt_ms_ent_cs_v.ms_ent_val) = SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'ID'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 5, CHARINDEX(convert(varchar, '}'), SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'ID'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 5, LEN(convert(varchar, idmrpt_idv_identity_trust.trust_params)))) - 2))))
                ELSE SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'EntitlementParamKey'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 21, CHARINDEX(convert(varchar, '</value>'), SUBSTRING(convert(varchar, idmrpt_idv_identity_trust.trust_params), CHARINDEX(convert(varchar, 'EntitlementParamKey'), convert(varchar, idmrpt_idv_identity_trust.trust_params)) + 21, LEN(convert(varchar, idmrpt_idv_identity_trust.trust_params)))) - 1)
            END
            ELSE bind_v.ent_param_val
        END),
        bind_v.ent_param_liid, idmrpt_identity.last_name, idmrpt_identity.first_name, idmrpt_identity.middle_initial;
GO     
GRANT SELECT ON IDM_RPT_DATA.IDMRPT_RES_TRUST_V TO idmrptuser;
CREATE SYNONYM IDMRPT_RES_TRUST_V for IDM_RPT_DATA.IDMRPT_RES_TRUST_V; 